﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SODTextConverter
{
    public partial class Form1 : Form
    {
        char[] znaki =
            {
                '^',
                'A','B','C','D','E','F','G','H','I','J',        //1-10
                'K','L','M','N','O','P','Q','R','S','T',        //11-20   
                'U','V','W','X','Y','Z',' ','.'                 //21-28
                                                                //29-nowa linia,30-zmiana koloru,31 rozszerzona lista znaków
                
                //',','/'','?'
                
            }
            ;

        int[] T =new int[500];

        char []rozdzielacze=new char[]
            {
                ' ',','
            };

        
        
        public Form1()
        {
            InitializeComponent();
        }

        private void tbxTekst_TextChanged(object sender, EventArgs e)
        {
            tbxDlugosc.Text = tbxTekst.Text.Length.ToString();
        }

        private void btnKopiuj_Click(object sender, EventArgs e)
        {
            tbxRezultat.SelectAll();
            tbxRezultat.Copy();
        }

        private void btnTlumacz_Click(object sender, EventArgs e)
        {
            
            int dlug = tbxTekst.Text.Length;      
            if (dlug == 0) return;
            string tekst = tbxTekst.Text;
          

            tbxRezultat.Text = " .BYTE ";

            for (int x = 0; x < dlug; x++)
            {             
                char znak = tekst[x];
             

                for (int y = 0; y <= znaki.Length; y++)
                {
                  
                    
                    if (y == znaki.Length)
                    {
                        tbxRezultat.Text = "BŁĄD!!!";
                        return;
                    }
                    
                    if (znak == znaki[y])
                    {
                        tbxRezultat.Text += y.ToString() + ",";
                        break;
                    }

                    if (znak == 13)                  //przejście do nowej linii
                    {
                        tbxRezultat.Text +="29,"; //symbol nowego wiersza dla spectrum
                        x++;                      //przejście do nowej linii to 2 bajty 0D 0A
                        break;
                    }

                    //symbole specjalne
                    if (znak == ',')
                    {
                        tbxRezultat.Text += "31,1,";
                        break;
                    }
                    if (znak == '\'')
                    {
                        tbxRezultat.Text += "31,2,";
                        break;
                    }
                    if (znak == '?')
                    {
                        tbxRezultat.Text += "31,3,";
                        break;
                    }
                    if (znak == '+')        //+ oznacza wielokropek
                    {
                        tbxRezultat.Text += "31,4,";
                        break;
                    }  






                }

                


            }
                    tbxRezultat.Text +="0";
        }

        private void btnGraf2Atr_Click(object sender, EventArgs e)
        {
            int adrGraf = Convert.ToInt32(tbxGrafikaAdr.Text);
            int h = adrGraf / 256;
            int l = adrGraf & 255;
            h = h / 8;
            h += 80;
            int adrAttr = h * 256 + l;
            tbxAttrAdr.Text = adrAttr.ToString();

        }

        private void btnKompresja_Click(object sender, EventArgs e)
        {
            tbxKompresja.Text = ".BYTE ";
           
            //czytaj liczby z textboxa wynik i zapisz je do tablicy
            
            int i = 0;                  //indeks tablicy
            string tekst1 = tbxRezultat.Text;

            foreach (string liczba in tekst1.Split(rozdzielacze))
            {
                if (liczba != ".BYTE" && liczba != "")
                {
                    i++;
                    T[i] = int.Parse(liczba);              
                }             
            }

            //czytaj liczby z tablicy i skompresuj je tak, by każda liczba zajmowała 5 bitów
            // np. tekst AAA jest bez kompresji zapisany jako 1,1,1
            //po kompresji zajmie 3 bajty i w zapisie dwójkowym będzie miał postać
            // 00001|000  01|0|00001 
            //a w dziesiętnym 8,65 (trzeci bit w drugim bajcie jest nieużywany

            int j = 1;
            while (true)
            {
                
                int bajt1 = T[j] * 8 + T[j + 1] / 4;
                tbxKompresja.Text += bajt1.ToString() + ",";
                if (T[j]==0&&T[j-1]!=30) break;                 //0 kończy tekst ,ale pod warunkiem, że nie jest poprzedzone
                                                                //liczbą 30 która oznacza ustawianie koloru

                
                int bajt2 = (T[j + 1] & 3) * 64 + T[j + 2];
                tbxKompresja.Text += bajt2.ToString() + ",";
                if (T[j + 1] == 0 && T[j] != 30) break;
                if (T[j + 2] == 0 && T[j + 1] != 30) break;
                           
                j += 3;                                             //następne 3 bajty
            }
        
        }
    }
}